/* The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Eric Hodel's <drbrain@segment7.net> code.
 * 
 * The Initial Developer of the Original Code is Eric Hodel.
 * Portions created by Eric Hodel are Copyright (C) 2001 Eric
 * Hodel. All Rights Reserved.
 * 
 * Other Contributors:
 *      Christopher Hoess <choess@force.stwing.upenn.edu>
 *      Tim Taylor <tim@tool-man.org>
 */


// Debug and testing code for logging and performance testing

function testRefresh() {
  profile("testIterateLinkElements", testIterateLinkElements);
  profile("testIterateLinkHeaders", testIterateLinkHeaders);
  profile("testIterateAnchorElements", testIterateAnchorElements);
}

function testIterateLinkElements() {
  var document = window._content.document;

  // technique #1
  //var nodeList = document.getElementsByTagName("LINK");

  // technique #2
  /*
  var node = document.firstChild;
  while (node.nodeName != "HTML")
    node = node.nextSibling;
  if (node.nodeName != "HEAD") {
    node = node.firstChild;
    while (node.nodeName != "HEAD")
      node = node.nextSibling;
  }
  var nodeList = node.getElementsByTagName("LINK");
  */

  // technique #3
  var nodeList = document.getElementsByTagName("HEAD").item(0).getElementsByTagName("LINK");

  iterateNodeList(nodeList);
}

function testIterateLinkHeaders() {
  //iterateHttpLinkHeaders();
  iterateHttpEquivLinkHeaders();
}

function iterateHttpLinkHeaders() {
  var document = window._content.document;

  ddump("testIterateLinkHeaders: document.URL = " + document.URL);
  getHTTPHeaders(document.URL);
  iterateArray(curDocHTTPHeaders);
}

function iterateHttpEquivLinkHeaders() {
  iterateNodeList(getHttpEquivLinks());
}

function testIterateAnchorElements() {
  var document = window._content.document;

  // technique #1
  //var nodeList = document.getElementsByTagName("A");

  // technique #2
  /*
  var node = document.firstChild.firstChild;  // document -> HTML
  while (node.tagName != "BODY") {
    node = node.nextSibling;
  }
  var nodeList = node.getElementsByTagName("A");
  */

  // technique #3
  var nodeList = document.links;

  iterateNodeList(nodeList);
}

function iterateNodeList(nodeList) {
  for (var i = 0; i < nodeList.length; i++)
    dump(nodeList.item(i));
}

function profile(name, func, args) {
  //ddump(name + " begin");
  var start = new Date();

  var result;
  if (args)
    result =  func.apply(this, args);
  else
    result =  func();

  var finish = new Date();
  //ddump(name + " end");
  ddump(name + ": completed in " + (finish.getTime() - start.getTime()) + " ms");

  return result;
}

function ddump(msg) {
  dump("LinkToolbar::" + msg + "\n");
}
