// this function verifies disk space in kilobytes
function verifyDiskSpace(dirPath, spaceRequired)
{
  var spaceAvailable;

  // Get the available disk space on the given path
  spaceAvailable = fileGetDiskSpaceAvailable(dirPath);

  // Convert the available disk space into kilobytes
  spaceAvailable = parseInt(spaceAvailable / 1024);

  // do the verification
  if (spaceAvailable < spaceRequired)
  {
    logComment("Insufficient disk space: " + dirPath);
    logComment("  required : " + spaceRequired + " K");
    logComment("  available: " + spaceAvailable + " K");
    return false;
  }

  return true;
}

// main code block

var err;
var gVersion = "2.0";
var srDest = 9;

var err = initInstall("Link Toolbar", "linktoolbar", gVersion);
logComment("initInstall: " + err);

var fChrome = getFolder("Chrome");
var fProgram = getFolder("Program");
logComment("fChrome: " + fChrome);

if (verifyDiskSpace(fProgram, srDest))
{
  err = addFile("Link Toolbar", gVersion, "linktoolbar.jar",fChrome,"", 0);
  logComment("addFile: " + err);

  registerChrome(CONTENT | DELAYED_CHROME, getFolder(fChrome, "linktoolbar.jar"), "content/linktoolbar/");
  registerChrome(LOCALE  | DELAYED_CHROME, getFolder(fChrome, "linktoolbar.jar"), "locale/en-US/linktoolbar/");
  registerChrome(SKIN    | DELAYED_CHROME, getFolder(fChrome, "linktoolbar.jar"), "skin/classic/linktoolbar/");
  registerChrome(SKIN    | DELAYED_CHROME, getFolder(fChrome, "linktoolbar.jar"), "skin/modern/linktoolbar/");

  if (getLastError() == SUCCESS)
  {
    err = performInstall(); 
    logComment("performInstall: " + err);
  }
  else
  {
    cancelInstall(err);
  }
}

